﻿namespace ProjectSportCar.CollectionGenericObjects;

/// <summary>
/// Параметризованный набор объектов
/// </summary>
/// <typeparam name="T">Параметр: ограничение - ссылочный тип</typeparam>
public class ListGenericObjects<T> : ICollectionGenericObjects<T>
	where T : class
{
	/// <summary>
	/// Список объектов, которые храним
	/// </summary>
	private readonly List<T?> _collection;

	/// <summary>
	/// Максимально допустимое число объектов в списке
	/// </summary>
	private int _maxCount;

	public int Count => _collection.Count;

	public int MaxCount
	{
		get => _maxCount;
		set
		{
			if (value > 0)
			{
				_maxCount = value;
			}
		}
	}


	public CollectionType GetCollectionType => throw new NotImplementedException();

	/// <summary>
	/// Конструктор
	/// </summary>
	public ListGenericObjects()
	{
		_collection = new();
	}

	public T? Get(int position)
	{
		// TODO проверка позиции
		// TODO выброс ошибки, если выход за границы массива
		return _collection[position];
	}

	public bool Insert(T obj, IEqualityComparer<T?>? comparer = null)
	{
		// TODO проверка, что не превышено максимальное количество элементов
		// TODO выброс ошибки, если переполнение
		// TODO вставка в конец набора
		return true;
	}

	public bool Insert(T obj, int position, IEqualityComparer<T?>? comparer = null)
	{
		// TODO проверка, что не превышено максимальное количество элементов
		// TODO выброс ошибки, если переполнение
		// TODO проверка позиции
		// TODO вставка по позиции
		return true;
	}

	public bool Remove(int position)
	{
		// TODO проверка позиции
		// TODO выброс ошибки, если выход за границы массива
		// TODO удаление объекта из списка
		return true;
	}

	public IEnumerable<T?> GetItems()
	{
		throw new NotImplementedException();
	}

	public void CollectionSort(IComparer<T?> comparer)
	{
		throw new NotImplementedException();
	}
}