﻿
using ProjectSportCar.Drawnings;

namespace ProjectSportCar.CollectionGenericObjects;

/// <summary>
/// Параметризованный набор объектов
/// </summary>
/// <typeparam name="T">Параметр: ограничение - ссылочный тип</typeparam>
public class MassiveGenericObjects<T> : ICollectionGenericObjects<T>
	where T : class
{
	/// <summary>
	/// Массив объектов, которые храним
	/// </summary>
	private T?[] _collection;

	public int Count => _collection.Length;

	public int MaxCount
	{
		get
		{
			return _collection.Length;
		}
		set
		{
			if (value > 0)
			{
				if (_collection.Length > 0)
				{
					Array.Resize(ref _collection, value);
				}
				else
				{
					_collection = new T?[value];
				}
			}
		}
	}

	public CollectionType GetCollectionType => CollectionType.Massive;

	/// <summary>
	/// Конструктор
	/// </summary>
	public MassiveGenericObjects()
	{
		_collection = Array.Empty<T?>();
	}

	public T? Get(int position)
	{
		// TODO проверка позиции
		// TODO выброс ошибки, если выход за границы массива
		// TODO выброс ошибки, если объект пустой
		return _collection[position];
	}

	public bool Insert(T obj, IEqualityComparer<T?>? comparer = null)
	{
		// TODO выборс ошибки, если такой объект есть в коллекции
		// TODO вставка в свободное место набора
		// TODO выброс ошибки, если переполнение
		return false;
	}

	public bool Insert(T obj, int position, IEqualityComparer<T?>? comparer = null)
	{
		// TODO выборс ошибки, если такой объект есть в коллекции
		// TODO проверка позиции
		// TODO выброс ошибки, если выход за границы массива
		// TODO проверка, что элемент массива по этой позиции пустой, если нет, то
		//		ищется свободное место после этой позиции и идет вставка туда
		//		если нет после, ищем до
		// TODO выброс ошибки, если переполнение
		// TODO вставка
		return false;
	}

	public bool Remove(int position)
	{
		// TODO проверка позиции
		// TODO выброс ошибки, если выход за границы массива
		// TODO выброс ошибки, если объект пустой
		// TODO удаление объекта из массива, присвоив элементу массива значение null
		return true;
	}

	public IEnumerable<T?> GetItems()
	{
		for (int i = 0; i < _collection.Length; ++i)
		{
			yield return _collection[i];
		}
	}

	public void CollectionSort(IComparer<T?> comparer)
	{
		throw new NotImplementedException();
	}
}