﻿using System.Diagnostics.CodeAnalysis;

namespace ProjectSportCar.Drawnings;

/// <summary>
/// Реализация сравнения двух объектов класса-прорисовки
/// </summary>
public class DrawiningCarEqutables : IEqualityComparer<DrawningCar?>
{
	public bool Equals(DrawningCar? x, DrawningCar? y)
	{
		if (x == null || x.EntityCar == null)
		{
			return false;
		}

		if (y == null || y.EntityCar == null)
		{
			return false;
		}

		if (x.GetType().Name != y.GetType().Name)
		{
			return false;
		}

		if (x.EntityCar.Speed != y.EntityCar.Speed)
		{
			return false;
		}

		if (x.EntityCar.Weight != y.EntityCar.Weight)
		{
			return false;
		}

		if (x.EntityCar.BodyColor != y.EntityCar.BodyColor)
		{
			return false;
		}

		if (x is DrawningSportCar && y is DrawningSportCar)
		{
			// TODO доделать логику сравнения дополнительных параметров
		}

		return true;
	}

	public int GetHashCode([DisallowNull] DrawningCar obj)
	{
		return obj.GetHashCode();
	}
}